﻿using System;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace JPGs_to_AVI_2 {
	static class Program {
		[STAThread]
		static void Main() {
			string[] args = System.Environment.GetCommandLineArgs();
			// debug CLPs: "C:\Dropbox\My Pictures\2002\newOrleans_techEd02" -nth 5
			if (args.Length > 1) {
				if (!Directory.Exists(args[1])) {
					AttachConsole(-1);
					Stream helptxt = Assembly.GetExecutingAssembly().GetManifestResourceStream("JPGs_to_AVI_2.help.txt");
					Console.Write(new StreamReader(helptxt).ReadToEnd());
					FreeConsole();
					return;
				}

				string sourceFolder = args[1];
				int v = 0;
				for (int i = 1; i < args.Length; i++) {
					switch (args[i].ToLower()) {
						case "-fpi": v = Convert.ToInt32(args[i + 1]) + 1; break;
						case "-nth": v = -Convert.ToInt32(args[i + 1]) - 1; break;
					}
				}

				// DisplayStart();
				Application.EnableVisualStyles();
				Application.SetCompatibleTextRenderingDefault(false);
				Application.Run(new mainForm(sourceFolder, v));

			} else {
				Application.EnableVisualStyles();
				Application.SetCompatibleTextRenderingDefault(false);
				Application.Run(new mainForm());
			}
		}

		// <summary>API-Call: Attaches the console to the application</summary>
		// <param name="dwProcessId">Console-ProcessID (-1 for the console from which the program was called)</param>
		// <returns>Boolean Success</returns>
		// <remarks>API-Call: AttachConsole in kernel32.dll<br/>
		// This Function atttaches a console (by its ProcessID) to the application, which allows us to print (with Console.Print*) directly into that console.
		// The console will not be blocked...</remarks>
		[DllImport("kernel32.dll")]
		public static extern bool AttachConsole(Int32 dwProcessId);

		// <summary>API-Call: Releases the attached console (if any)</summary>
		// <returns>Boolean Success</returns>
		// <remarks>API-Call: FreeConsole in kernel32.dll<br/>
		// This function releases the attached console (if any).</remarks>
		[DllImport("kernel32.dll")]
		public static extern bool FreeConsole();
	}
}
